
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Audit_logsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.create(
            {
                id: data.id || undefined,
        
        action: data.action
        ||
        null
            ,
            
        entity_name: data.entity_name
        ||
        null
            ,
            
        entity_reference: data.entity_reference
        ||
        null
            ,
            
        details: data.details
        ||
        null
            ,
            
        logged_at: data.logged_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await audit_logs.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await audit_logs.setActor( data.actor || null, {
            transaction,
        });
        
        await audit_logs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return audit_logs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const audit_logsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                action: item.action
            ||
            null
            ,
            
                entity_name: item.entity_name
            ||
            null
            ,
            
                entity_reference: item.entity_reference
            ||
            null
            ,
            
                details: item.details
            ||
            null
            ,
            
                logged_at: item.logged_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const audit_logs = await db.audit_logs.bulkCreate(audit_logsData, { transaction });

        // For each item created, replace relation files
        

        return audit_logs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const audit_logs = await db.audit_logs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.action !== undefined) updatePayload.action = data.action;
        
        
        if (data.entity_name !== undefined) updatePayload.entity_name = data.entity_name;
        
        
        if (data.entity_reference !== undefined) updatePayload.entity_reference = data.entity_reference;
        
        
        if (data.details !== undefined) updatePayload.details = data.details;
        
        
        if (data.logged_at !== undefined) updatePayload.logged_at = data.logged_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await audit_logs.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await audit_logs.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.actor !== undefined) {
            await audit_logs.setActor(
              
              data.actor,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await audit_logs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return audit_logs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of audit_logs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of audit_logs) {
                await record.destroy({transaction});
            }
        });


        return audit_logs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findByPk(id, options);

        await audit_logs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await audit_logs.destroy({
            transaction
        });

        return audit_logs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findOne(
            { where },
            { transaction },
        );

        if (!audit_logs) {
            return audit_logs;
        }

        const output = audit_logs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await audit_logs.getWorkspace({
            transaction
        });
        
        
        output.actor = await audit_logs.getActor({
            transaction
        });
        
        
        output.organizations = await audit_logs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'actor',
        
        where: filter.actor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.actor.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.actor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.entity_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'entity_name',
                        filter.entity_name,
                    ),
                };
            }
            
            if (filter.entity_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'entity_reference',
                        filter.entity_reference,
                    ),
                };
            }
            
            if (filter.details) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'details',
                        filter.details,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            logged_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    logged_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.logged_atRange) {
                const [start, end] = filter.logged_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    logged_at: {
                    ...where.logged_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    logged_at: {
                    ...where.logged_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.action) {
                where = {
                    ...where,
                action: filter.action,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.audit_logs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'audit_logs',
                        'action',
                        query,
                    ),
                ],
            };
        }

        const records = await db.audit_logs.findAll({
            attributes: [ 'id', 'action' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['action', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.action,
        }));
    }

    
};

